const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const forum_posts = sequelize.define(
    'forum_posts',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

body_text: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"visible",


"hidden",


"removed"

        ],

      },

posted_at: {
        type: DataTypes.DATE,
      
      

      },

upvotes_count: {
        type: DataTypes.INTEGER,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  forum_posts.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.forum_posts.belongsTo(db.forum_threads, {
      as: 'thread',
      foreignKey: {
        name: 'threadId',
      },
      constraints: false,
    });

    db.forum_posts.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.forum_posts.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.forum_posts.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.forum_posts.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return forum_posts;
};


